/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-network-monitor-udp-1.0.9-0quantal-20150330-0832/obj-x86_64-linux-gnu/devel/share/network_monitor_udp/msg/LinktestResult.msg
 *
 */


#ifndef NETWORK_MONITOR_UDP_MESSAGE_LINKTESTRESULT_H
#define NETWORK_MONITOR_UDP_MESSAGE_LINKTESTRESULT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace network_monitor_udp
{
template <class ContainerAllocator>
struct LinktestResult_
{
  typedef LinktestResult_<ContainerAllocator> Type;

  LinktestResult_()
    : latency(0.0)
    , loss(0.0)
    , bandwidth(0.0)
    , latency_histogram()  {
    }
  LinktestResult_(const ContainerAllocator& _alloc)
    : latency(0.0)
    , loss(0.0)
    , bandwidth(0.0)
    , latency_histogram(_alloc)  {
    }



   typedef float _latency_type;
  _latency_type latency;

   typedef float _loss_type;
  _loss_type loss;

   typedef float _bandwidth_type;
  _bandwidth_type bandwidth;

   typedef std::vector<float, typename ContainerAllocator::template rebind<float>::other >  _latency_histogram_type;
  _latency_histogram_type latency_histogram;




  typedef boost::shared_ptr< ::network_monitor_udp::LinktestResult_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::network_monitor_udp::LinktestResult_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct LinktestResult_

typedef ::network_monitor_udp::LinktestResult_<std::allocator<void> > LinktestResult;

typedef boost::shared_ptr< ::network_monitor_udp::LinktestResult > LinktestResultPtr;
typedef boost::shared_ptr< ::network_monitor_udp::LinktestResult const> LinktestResultConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::network_monitor_udp::LinktestResult_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::network_monitor_udp::LinktestResult_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace network_monitor_udp

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'diagnostic_msgs': ['/opt/ros/hydro/share/diagnostic_msgs/cmake/../msg'], 'network_monitor_udp': ['/tmp/buildd/ros-hydro-network-monitor-udp-1.0.9-0quantal-20150330-0832/msg', '/tmp/buildd/ros-hydro-network-monitor-udp-1.0.9-0quantal-20150330-0832/obj-x86_64-linux-gnu/devel/share/network_monitor_udp/msg'], 'actionlib': ['/opt/ros/hydro/share/actionlib/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::network_monitor_udp::LinktestResult_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::network_monitor_udp::LinktestResult_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::network_monitor_udp::LinktestResult_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::network_monitor_udp::LinktestResult_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::network_monitor_udp::LinktestResult_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::network_monitor_udp::LinktestResult_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::network_monitor_udp::LinktestResult_<ContainerAllocator> >
{
  static const char* value()
  {
    return "cde18aa0ddbb2c88ca3e62eb27f8aa3f";
  }

  static const char* value(const ::network_monitor_udp::LinktestResult_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xcde18aa0ddbb2c88ULL;
  static const uint64_t static_value2 = 0xca3e62eb27f8aa3fULL;
};

template<class ContainerAllocator>
struct DataType< ::network_monitor_udp::LinktestResult_<ContainerAllocator> >
{
  static const char* value()
  {
    return "network_monitor_udp/LinktestResult";
  }

  static const char* value(const ::network_monitor_udp::LinktestResult_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::network_monitor_udp::LinktestResult_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
# Result definition\n\
float32 latency\n\
float32 loss\n\
float32 bandwidth \n\
float32[] latency_histogram\n\
";
  }

  static const char* value(const ::network_monitor_udp::LinktestResult_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::network_monitor_udp::LinktestResult_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.latency);
      stream.next(m.loss);
      stream.next(m.bandwidth);
      stream.next(m.latency_histogram);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct LinktestResult_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::network_monitor_udp::LinktestResult_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::network_monitor_udp::LinktestResult_<ContainerAllocator>& v)
  {
    s << indent << "latency: ";
    Printer<float>::stream(s, indent + "  ", v.latency);
    s << indent << "loss: ";
    Printer<float>::stream(s, indent + "  ", v.loss);
    s << indent << "bandwidth: ";
    Printer<float>::stream(s, indent + "  ", v.bandwidth);
    s << indent << "latency_histogram[]" << std::endl;
    for (size_t i = 0; i < v.latency_histogram.size(); ++i)
    {
      s << indent << "  latency_histogram[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.latency_histogram[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // NETWORK_MONITOR_UDP_MESSAGE_LINKTESTRESULT_H
